#include <usb.h>
#include "lcd.h"
#include "usb_my.h"

static unsigned char framebuffer_cur[WIDTH][PHEIGHT] = {};	/*! */

static unsigned char framebuffer_old[WIDTH][PHEIGHT] = {};	/*! */

static void
update_framebuffer (void)
{				/*!       */
  int i, j;
  for (i = 0; i < WIDTH; i++)
    {
      for (j = 0; j < PHEIGHT; j++)
	{
	  framebuffer_old[i][j] = framebuffer_cur[i][j];
	};
    };
};


static void force_full_update(){
	int i,j;
	for(j=0;j<WIDTH;j++) for(i=0;i<PHEIGHT;i++) framebuffer_old[j][i]=~framebuffer_cur[j][i];
};

void
update_screen (usb_dev_handle * handle)
{
  int i, j, k, length;
  unsigned char buffer[MAX_PACKET];
  for (j = 0; j < PHEIGHT; j++)
    {
      for (i = 0; i < WIDTH; i++)
	{
	  if (framebuffer_cur[i][j] != framebuffer_old[i][j])
	    {
	      length = 3;
	      buffer[0] = i;
	      buffer[1] = j;
	      buffer[2] = framebuffer_cur[i][j];
	      k = 0;
	      while ((framebuffer_cur[i + k][j] != framebuffer_old[i + k][j])
		     && (k < (MAX_PACKET-2)) && ((i + k) < WIDTH))
		{
		  k++;
		  buffer[length] = framebuffer_cur[i + k][j];
		  length++;
		};
	      send_data_to_device (handle, buffer, length);
	      i += k;
	    };
	};
    };
  update_framebuffer ();
};

void putpixel(unsigned char x,unsigned char y,unsigned char value){
	unsigned char mask;
	if(x<WIDTH){
		if(y<HEIGHT){
			mask=(1<<(y%8));
			if(value){
				framebuffer_cur[x][y>>3]=(framebuffer_cur[x][y>>3])|mask;
			}else{
				framebuffer_cur[x][y>>3]=(framebuffer_cur[x][y>>3])&(~mask);
			};
		};
	};
};

void clearscreen(unsigned char value){
	int i,j;
	for(i=0;i<WIDTH;i++){
		for(j=0;j<PHEIGHT;j++){
			framebuffer_cur[i][j]=value;
		};
	};
	force_full_update();
};
