#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <usb.h>
#include "usb_my.h"
#include "lcd.h"
#include "logo.xbm"

int
main (int argc, char **argv)
{
  usb_dev_handle *handle = NULL;
  usb_init ();
  if ((handle = findDevice ()) == NULL)
    {
      fprintf (stderr,
	       "Could not find USB device \"HID LCD\" with vid=0x%x pid=0x%x\n",
	       USBDEV_SHARED_VENDOR, USBDEV_SHARED_PRODUCT);
      exit (1);
    }
  int i, j;
  clearscreen(0);update_screen(handle);  
  int k,v,n;
  for(i=0;i<(logo_width>>3);i++){
    for(j=0;j<logo_height;j++){
		v=logo_bits[(i*(logo_height+j)>>3)];
		n=128;
		for(k=0;k<8;k++){
		    putpixel(j,i*8+k,v&n);
		    n>>=1;
		};
	};
	
  };
  update_screen(handle);    
  printf ("test succeeded\n");
  usb_close (handle);
  return 0;
}
